<!DOCTYPE html>
<html>
<head>
  <title>Promises test</title>
  <link rel="stylesheet" href="styles.css">
</head>
<body>
  <div class="network-fake">
    <label><input type="checkbox"> Fake network delay</label>
  </div>
  <div class="story"></div>
  <svg class="spinner" viewBox="0 0 100 100" width="20" height="20">
    <circle cx="50" cy="50" r="42" transform="rotate(-90,50,50)" />
  </svg>
  <script src="../js/utils.js"></script>
  <script>
    getJson('../data/story.json').then(function(story) {
      addHtmlToPage(story.heading);
      return story.chapterUrls.reduce(function(chain, chapterUrl) {
        // Once the last chapter's promise is done…
        return chain.then(function() {
          // …fetch the next chapter
          return getJson(chapterUrl);
        }).then(function(chapter) {
          // and add it to the page
          addHtmlToPage(chapter.html);
        });
      }, Promise.resolve());
    }).then(function() {
      // And we're all done!
      addTextToPage("All done");
    }).catch(function(err) {
      // Catch any error that happened along the way
      addTextToPage("Argh, broken: " + err.message);
    }).then(function() {
      // Always hide the spinner
      document.querySelector('.spinner').style.display = 'none';
    });
  </script>
</body>
</html>